#include <iostream>
#include <ctime>
#include <cstdlib>

using namespace std;

const int NUM_SIZE = 10, USER_PIN_SIZE = 5;
const int SECRET[5] = {1, 2, 3, 4, 5};  // make up a password

void createPinNumbers(int pin[], int size);

void convertNumToArray(int num, int arr[], int size);

bool checkValidity(int pin[], int user_pin[], const int secret[], int secret_length);

int main() {
    cout << "Please enter your PIN according to the following mapping:\n"
         << "PIN: 0 1 2 3 4 5 6 7 8 9\nNUM: ";
    int pin_numbers[NUM_SIZE];
    createPinNumbers(pin_numbers, NUM_SIZE);

    int user_input;
    cin >> user_input;
    int user_pin[USER_PIN_SIZE];
    convertNumToArray(user_input, user_pin, USER_PIN_SIZE);

    bool is_valid = checkValidity(pin_numbers, user_pin, SECRET, USER_PIN_SIZE);
    cout << "Your PIN is" << (is_valid ? " " : " not ") << "correct\n";
    return 0;
}

void createPinNumbers(int pin[], int size) {
    srand(time(0));
    int i = 0;
    while (i < size) {
        pin[i] = rand() % 3 + 1;
        cout << pin[i] << " ";
        ++i;
    }
    cout << endl;
}

void convertNumToArray(int num, int arr[], int size) {
    for (int i = size - 1; i >= 0; --i) {
        arr[i] = num % 10;
        num /= 10;
    }
}

bool checkValidity(int pin[], int user_pin[], const int secret[], int secret_length) {
    for (int i = 0; i < secret_length; ++i) {
        if (pin[secret[i]] != user_pin[i]) return false;
    }
    return true;
}